#ifndef OPENGL_H_
#define OPENGL_H_

#include <EGL/egl.h>
#include <EGL/eglext.h>

/**
 *
 * \addtogroup libgui
 *
 *  @{
 */
#include <GLES2/gl2.h>
#include <GLES2/gl2ext.h>

extern "C" bool eglErrorCheck();
#ifndef NDEBUG
void glErrorCheck( const char* file =0, const int line = 0);
#else
#define glErrorCheck(x,y)
#endif

void printEGLConfigs(EGLDisplay d);
void initEGLFunctions();

inline int nextLargerPowerOfTwo( int val )
{
    --val;
    val = (val >> 1) | val;
    val = (val >> 2) | val;
    val = (val >> 4) | val;
    val = (val >> 8) | val;
    val = (val >> 16) | val;
    ++val; // Val is now the next highest power of 2.
    return val < 16 ? 16 : val;
}

/** @} */

#endif // OPENGL_H_

