#if defined (__cplusplus)
extern "C" {
#endif

#include <linux/ioctl.h>


union SCMEM_AllocUnion {
    struct {			/**< */
        size_t size;
        unsigned long long physp;
    } pool_params;	/**< */

    struct {			/**< */
        size_t size;
        unsigned long long flags;
    } alloc_params;	/**< */

};

#define SCMEM_IOCMAGIC                   0x000000A1
#define SCMEM_IOC_BASE                   0x000000B0

#define SCMEM_IOC_ALLOC                 _IOWR(   SCMEM_IOCMAGIC, SCMEM_IOC_BASE + 1, union SCMEM_AllocUnion* )
#define SCMEM_IOC_FREE                  _IOW (   SCMEM_IOCMAGIC, SCMEM_IOC_BASE + 2, union SCMEM_AllocUnion* )

#define SCMEM_IOC_GETDMAFD              _IOW (   SCMEM_IOCMAGIC, SCMEM_IOC_BASE + 3, unsigned long long)
#define SCMEM_IOC_GETPHYS               _IOWR(   SCMEM_IOCMAGIC, SCMEM_IOC_BASE + 4, unsigned long long) // currently implemented but not used

#define SCMEM_IOC_GET_MEM_PARAMS        _IOR(    SCMEM_IOCMAGIC, SCMEM_IOC_BASE + 5, union SCMEM_AllocUnion* )



// Alloc flags
#define SCMEM_CACHED                    0x00080000  /**< allocated buffer is cached */

#if defined (__cplusplus)
}
#endif
